//+------------------------------------------------------------------+
//|                                                  NeuroCandle.mq4 |
//|                             Copyright  2007, Victor I/ Nicolaev |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Victor I. Nicolaev"
#property link      "vinin@mail.ru"
//---- input parameters
#define CMD_NO        -1
#define CMD_OPEN_BUY   0
#define CMD_OPEN_SELL  1
#define CMD_CLOSE_BUY  2
#define CMD_CLOSE_SELL 3
#define CMD_CLOSE_ALL  4


extern int icmd=-1; 
extern int mode_open=-1;
extern int mode_close=-1;
extern int iPeriod=-1; 

extern int tp=100; 
extern int sl= 85; 


extern int MaximumRisk = 2; 

double       minlot = 0.1; 


int          prevtime[]={0,0,0}; 
int TM[]={1440,240,60}; 
extern int BarCount=117; 
//D1-117
int Magic[]={200701,200702,200703}; 
int cmd[]={CMD_NO,CMD_NO,CMD_NO}; 
int Trend[]={0,0,0};

double   body_s[3]; 
double   body_b[3];
double   shadow_s[3]; 
double   shadow_b[3]; 
double   MA2[]={0,0,0};

double lots; 
string _comment=""; 
int Command[3][250]; 

#include <CandleKOH.mq4>
#include <Statistika.mqh>
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   KOHReadMem(WW); 
   ArrayInitialize(Command,-1); CommandReadMEM();
   return(0); 
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){
   HistoryCalculate(); 
   return(0); 
  }

int start(){
   if (iPeriod==-1) 
      for (int i=0; i<3; i++) {
         if (iBars(Symbol(),TM[i])<BarCount) return(0); 
         start_period(i); 
      }
   else {
      if (iBars(Symbol(),TM[iPeriod])<BarCount) return(0); 
      start_period(iPeriod); 
   }
   return(0);
}

int start_period(int iP) {
//   if (cmd_open==cmd_close) return(0); 
//   int i,j,k; 
   int cmdKoh,cmd_open=-1,cmd_close=-1; 
   int cmd_nev=-1; 
   Order_Modify(Magic[iP]); 
   if (iTime(Symbol(),TM[iP],0) == prevtime[iP]) return(0); 
   prevtime[iP] = iTime(Symbol(),TM[iP],0); 
   double MA1=iMA(Symbol(),TM[iP],3,0,MODE_SMA,PRICE_CLOSE,1);
   if (MA2[iP]==0) {MA2[iP]=MA1; return(0);}
   int TrendNev=ComparePrice(MA1,MA2[iP],Point/10);
   MA2[iP]=MA1;
   if (TrendNev==Trend[iP]) return(0);
   Trend[iP]=TrendNev;
   CandleRefresh(iP);  
   aCandleCode(iP, 1,Candle); 
   cmdKoh=KOHWork(WW,Candle); 
   cmd_nev=CommandKoh(iP,cmdKoh);
   if (cmd_nev==4) {Order_Close_All(Magic[iP]); cmd[iP]=-1;return(0);}
   if (cmd_nev>=2 && cmd_nev<=3) cmd_close=cmd_nev;
   if (cmd_nev>=0 && cmd_nev<=1) cmd_open=cmd_nev;
   if (cmd_close-cmd[iP]==2 && cmd[iP]!=-1) {Order_Close(cmd[iP],Magic[iP]); cmd[iP]=-1;}
   _comment=iP+";"+cmdKoh+";"+cmd_open;
   lots=getLots(); 
   if(TotalMagic(Magic[iP])==0 && cmd_open>=0 && cmd_open<=1) {Order_Open(cmd_open,Magic[iP]); cmd[iP]=cmd_open; }
   return(0); 
  }
//+------------------------------------------------------------------+

double getLots() {
   int round = MathAbs(MathLog(minlot) / MathLog(10.0)) + 0.5; 
   double lot = minlot; 
//---- select lot size
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 100000.0, round); 
   if (AccountFreeMargin() < lot * MarketInfo(Symbol(), MODE_MARGINREQUIRED)) {
      lot = NormalizeDouble(AccountFreeMargin() / MarketInfo(Symbol(), MODE_MARGINREQUIRED), round); 
   }
   if(lot < minlot) lot = minlot; 
   double maxlot = MarketInfo(Symbol(), MODE_MAXLOT); 
   if (maxlot>5) maxlot=5;
   if(lot > maxlot) lot = maxlot; 
//---- return lot size
   return(lot); 
}

int TotalMagic(int Magic){
   int Count=0; 
   int total = OrdersTotal(); 
   for (int i = 0;  i < total;  i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
         Count++; 

   }
   return(Count); 
}

bool Order_Modify(int Magic){
   double _sl, _tp; 
   int _cmd; 
   int total= OrdersTotal();    
   for(int i = total - 1;  i >= 0;  i--) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);  
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) {
         _cmd=-Sign(OrderType()-0.5); 
         _sl=iif(_cmd>0,Bid,Ask) - _cmd*sl * Point; 
         _tp=iif(_cmd>0,Bid,Ask) + _cmd*tp * Point; 
         if ((_sl-OrderStopLoss())*_cmd>0)
            OrderModify(OrderTicket(), OrderOpenPrice(), _sl, _tp, 0, iif(_cmd>0,Blue,Red)); 
      }
   }
}
void Order_Close_All(int Magic){
   int total= OrdersTotal();    
   int cmd;
   for(int i = total - 1;  i >= 0;  i--) 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) 
      && OrderSymbol() == Symbol() 
      && OrderMagicNumber() == Magic) {
         cmd=OrderType();
         OrderClose(OrderTicket(), OrderLots(), iif(cmd==OP_BUY,Bid,Ask), 3, iif(cmd==OP_BUY,Red,Blue)); 
      }
}

void Order_Close(int cmd, int Magic){
   int total= OrdersTotal();    
   for(int i = total - 1;  i >= 0;  i--) 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) 
      && OrderSymbol() == Symbol() 
      && OrderMagicNumber() == Magic
      && OrderType()==cmd)
         OrderClose(OrderTicket(), OrderLots(), iif(cmd==OP_BUY,Bid,Ask), 3, iif(cmd==OP_BUY,Red,Blue)); 
}

int Sign(double A) {if(A>0) return(1); if(A<0) return(-1); return(0); }
double iif(bool A, double B, double C) {if(A) return(B); return(C); }

int Order_Open(int cmd,int Magic){
   int _cmd=-Sign(cmd-0.5); 
   double price= iif(cmd==OP_BUY,Ask,Bid); 
   double _sl; 
   _sl=iif(sl==0,0,iif(cmd==OP_BUY,Bid,Ask) - _cmd*sl * Point); 
   double _tp; 
   _tp=iif(tp==0,0,iif(cmd==OP_BUY,Bid,Ask) + _cmd*tp * Point); 
   int ticket=OrderSend(Symbol(), cmd, lots,price, 3,_sl, _tp,_comment,Magic, 0, iif(cmd==OP_BUY,Blue,Red)); 
   return(ticket); 
}

void aCandleCode(int iPeriod, int k,double &Candle[]) {
   

   int RetVal=1; 
   double tmp; 
   for (int i=0; i<CandleCount/3; i++){
      tmp=(iClose(Symbol(),iPeriod,k+1+i)-iClose(Symbol(),iPeriod,k+i))/Point; 
      Candle[i*3+0]=0; 
      Candle[i*3+1]=0; 
      Candle[i*3+2]=0; 
      if (tmp!=0) {
         if (tmp<0) {tmp*=-1.0;  RetVal=-1; }
         if (tmp > 0)       Candle[i*3+0]+=0.5; 
         if (tmp > body_s[iPeriod])  Candle[i*3+0]+=0.5; 
         if (tmp > body_b[iPeriod] ) Candle[i*3+0]+=0.5; 
      }
      Candle[i*3+0]*=RetVal; 
      tmp=(iHigh(Symbol(),iPeriod,k+i)-MathMax(iClose(Symbol(),iPeriod,k+1+i),iClose(Symbol(),iPeriod,k+i)))/Point; 
      if (tmp>0)        Candle[i*3+1]++; 
      if (tmp>shadow_s[iPeriod]) Candle[i*3+1]++; 
      if (tmp>shadow_b[iPeriod]) Candle[i*3+1]++; 
      Candle[i*3+1]-=1.5; 
      tmp=(MathMin(iClose(Symbol(),iPeriod,k+1+i),iClose(Symbol(),iPeriod,k+i))-iLow(Symbol(),iPeriod,k+i))/Point; 
      if (tmp>0)        Candle[i*3+2]++; 
      if (tmp>shadow_s[iPeriod]) Candle[i*3+2]++; 
      if (tmp>shadow_b[iPeriod]) Candle[i*3+2]++; 
      Candle[i*3+2]-=1.5; 
   }
}

   
string PeriodToStr(int iPeriod){
   string sRetVal="_"; 
   switch (iPeriod) {
      case PERIOD_M1:  {sRetVal="M1";  break; }
      case PERIOD_M5:  {sRetVal="M5";  break; }
      case PERIOD_M15: {sRetVal="M15";  break; }
      case PERIOD_M30: {sRetVal="M30";  break; }
      case PERIOD_H1:  {sRetVal="H1";  break; }
      case PERIOD_H4:  {sRetVal="H4";  break; }
      case PERIOD_D1:  {sRetVal="D1";  break; }
      case PERIOD_W1:  {sRetVal="W1";  break; }
      case PERIOD_MN1: {sRetVal="MN1";  break; }
   }
   return(sRetVal); 
}
void CandleRefresh(int iPeriod){
   CandleBody(iPeriod); 
   CandleShadow(iPeriod); 
}
   
void CandleBody(int iPeriod){
   double Trend[]; 
   double x,c,xs; 
   int i,j; 
   int D,H; 
   ArrayResize(Trend,BarCount); 
   j=0; 
   x=0; 
   for (i=1; i<=BarCount; i++){
      if (TimeDayOfWeek(iTime(Symbol(),iPeriod,i))==5) {continue; }
      Trend[j]=(MathAbs(iClose(Symbol(),iPeriod,i+1)-iClose(Symbol(),iPeriod,i)))/Point;  
      x+=Trend[j]; 
      j++; 
   }
   int C=j; 
   c=C; 
   x=x/c; 
   for (i=0; i<C; i++){xs+=(x-Trend[i])*(x-Trend[i]); }
   xs=MathSqrt(xs/(c+1)); 
   body_s[iPeriod]=x-xs/2.0; 
   body_b[iPeriod]=x+xs/2.0; 
   return(0); 
}

void CandleShadow(int iPeriod){
   double Trend[][2]; 
   double x,c,xs; 
   int i,j; 
   int D,H;    
   ArrayResize(Trend,BarCount); 
   x=0; 
   for (i=1; i<BarCount; i++){
      if (TimeDayOfWeek(iTime(Symbol(),iPeriod,i))==5) {continue; }
      Trend[j,0]=(iHigh(Symbol(),iPeriod,i)-MathMax(iClose(Symbol(),iPeriod,i+1),iClose(Symbol(),iPeriod,i)))/Point; 
      Trend[j,1]=(MathMin(iClose(Symbol(),iPeriod,i+1),iClose(Symbol(),iPeriod,i))-iLow(Symbol(),iPeriod,i))/Point;  
      x+=Trend[j,0]; 
      x+=Trend[j,1]; 
      j++; 
   }
   int C=j; 
   c=j; 
   x=x/(2.0*c); 
   for (i=0; i<C; i++){
      xs+=(x-Trend[i,0])*(x-Trend[i,0]); 
      xs+=(x-Trend[i,1])*(x-Trend[i,1]); 
   }
   xs=MathSqrt(xs/(2.0*c+1.0)); 
   shadow_s[iPeriod]=x-xs/2.0; 
   shadow_b[iPeriod]=x+xs/2.0; 
   return(0); 
}

int ComparePrice(double a, double b, double digit) {
    a -= b;
    b = digit;
    if (a > b) return (1);
    if (a < -b)return (-1);
    return (0);
}


int CommandKoh(int iP,int K){
   if(mode_open!=-1 && icmd==K) return(mode_open);   
   if (mode_close!=-1 && Command[iP,K]==-1 && icmd==K) return(mode_close);
   return(Command[iP,K]);
}   


void CommandReadMEM(){
Command[	0	,	0	]=	0	;
Command[	0	,	1	]=	0	;
Command[	0	,	4	]=	1	;
Command[	0	,	10	]=	1	;
Command[	0	,	12	]=	1	;
Command[	0	,	14	]=	0	;
Command[	0	,	27	]=	0	;
Command[	0	,	31	]=	0	;
Command[	0	,	32	]=	0	;
Command[	0	,	35	]=	0	;
Command[	0	,	36	]=	0	;
Command[	0	,	38	]=	0	;
Command[	0	,	39	]=	0	;
Command[	0	,	43	]=	1	;
Command[	0	,	53	]=	0	;
//Command[	0	,	54	]=	0	;
//Command[	0	,	54	]=	1	;
Command[	0	,	57	]=	0	;
Command[	0	,	59	]=	0	;
Command[	0	,	65	]=	1	;
Command[	0	,	68	]=	1	;
Command[	0	,	70	]=	0	;
Command[	0	,	76	]=	0	;
Command[	0	,	78	]=	1	;
Command[	0	,	87	]=	0	;
Command[	0	,	90	]=	0	;
Command[	0	,	92	]=	0	;
Command[	0	,	97	]=	1	;
Command[	0	,	104	]=	0	;
Command[	0	,	108	]=	0	;
Command[	0	,	117	]=	0	;
Command[	0	,	118	]=	0	;
//Command[	0	,	133	]=	0	;
//Command[	0	,	133	]=	1	;
Command[	0	,	134	]=	0	;
Command[	0	,	135	]=	1	;
Command[	0	,	138	]=	0	;
Command[	0	,	140	]=	0	;
//Command[	0	,	141	]=	0	;
//Command[	0	,	141	]=	1	;
Command[	0	,	142	]=	0	;
Command[	0	,	143	]=	1	;
Command[	0	,	144	]=	0	;
Command[	0	,	149	]=	0	;
Command[	0	,	151	]=	0	;
Command[	0	,	155	]=	0	;
Command[	0	,	160	]=	0	;
Command[	0	,	164	]=	1	;
Command[	0	,	168	]=	1	;
Command[	0	,	172	]=	1	;
Command[	0	,	182	]=	0	;
Command[	0	,	183	]=	1	;
Command[	0	,	186	]=	0	;
Command[	0	,	189	]=	0	;
Command[	0	,	191	]=	1	;
Command[	0	,	194	]=	1	;
Command[	0	,	195	]=	1	;
Command[	0	,	196	]=	0	;
Command[	0	,	214	]=	0	;
Command[	0	,	216	]=	1	;
Command[	0	,	217	]=	1	;
Command[	0	,	220	]=	1	;
Command[	0	,	223	]=	1	;
Command[	0	,	234	]=	0	;
Command[	0	,	237	]=	0	;
Command[	0	,	240	]=	0	;
Command[	0	,	243	]=	0	;
//Command[	0	,	244	]=	0	;
//Command[	0	,	244	]=	1	;
Command[	0	,	245	]=	1	;
Command[	0	,	249	]=	1	;

Command[	0	,	9	]=	3	;
Command[	0	,	29	]=	2	;
Command[	0	,	30	]=	3	;
Command[	0	,	63	]=	3	;
Command[	0	,	115	]=	3	;
Command[	0	,	119	]=	3	;
Command[	0	,	141	]=	2	;
Command[	0	,	154	]=	3	;
Command[	0	,	159	]=	4	;
Command[	0	,	180	]=	2	;
Command[	0	,	219	]=	3	;
Command[	0	,	244	]=	2	;
}


